﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices; // 동적으로 컴파일러 관련 옵션을 업데이트하는 값을 넣기 위한 부분 
using System.Reflection; // 현재 어셈블리 정보를 동적으로 가져오기 위한 부분 
using Microsoft.Win32; // Registry에 정보를 업데이트 하기 위한 부분

namespace ActiveXTest
{
    [Guid("20F0F02D-044C-4013-AFAE-F2241D95FDA3")]
    [ComVisible(true)]
    [ProgId("HindNo1.TestAX")]
    [ClassInterface(ClassInterfaceType.AutoDual)] 
    public partial class UserControl1 : UserControl
    {

        [ComRegisterFunction()]
        public static void RegisterClass(string key)
        {
            // Strip off HKEY_CLASSES_ROOT\ from the passed key as I don't need it 
            StringBuilder sb = new StringBuilder(key);
            sb.Replace(@"HKEY_CLASSES_ROOT\", "");

            // Open the CLSID\{guid} key for write access 
            RegistryKey k = Registry.ClassesRoot.OpenSubKey(sb.ToString(), true);

            // And create    the    'Control' key -    this allows    it to show up in 
            // the ActiveX control container 
            RegistryKey ctrl = k.CreateSubKey("Control");
            ctrl.Close();

            // Next create the CodeBase entry    - needed if    not    string named and GACced. 
            RegistryKey inprocServer32 = k.OpenSubKey("InprocServer32", true);
            inprocServer32.SetValue("CodeBase", Assembly.GetExecutingAssembly().CodeBase);
            inprocServer32.Close();

            // Finally close the main    key 
            k.Close();
            MessageBox.Show(key + " 's registered");
        }

        ///    <summary> 
        ///    Called to unregister the control 
        ///    </summary> 
        ///    <param name="key">Tke registry key</param> 
        [ComUnregisterFunction()]
        public static void UnregisterClass(string key)
        {
            StringBuilder sb = new StringBuilder(key);
            sb.Replace(@"HKEY_CLASSES_ROOT\", "");

            // Open    HKCR\CLSID\{guid} for write    access 
            RegistryKey k = Registry.ClassesRoot.OpenSubKey(sb.ToString(), true);

            // Delete the 'Control'    key, but don't throw an    exception if it    does not exist 
            k.DeleteSubKey("Control", false);

            // Next    open up    InprocServer32 
            RegistryKey inprocServer32 = k.OpenSubKey("InprocServer32", true);

            // And delete the CodeBase key,    again not throwing if missing 
            k.DeleteSubKey("CodeBase", false);

            // Finally close the main key 
            k.Close();
        }

        public UserControl1()
        {
            InitializeComponent();
        }
    }
}
